Package org.apache.sling.distribution.resources.impl.common

## Class AbstractReadableResourceProvider

- java.lang.Object
- - org.apache.sling.distribution.resources.impl.common.AbstractReadableResourceProvider

All Implemented Interfaces:
  `org.apache.sling.api.resource.ResourceProvider`

Direct Known Subclasses:
  `AbstractModifyingResourceProvider`

    public abstract class AbstractReadableResourceProvider
    extends Object
    implements org.apache.sling.api.resource.ResourceProvider

a readable `ResourceProvider` for distribution.

### Field Summary

Fields
`protected static String` `INTERNAL_ADAPTABLE`
`protected static String` `INTERNAL_ITEMS_ITERATOR`
`static String` `INTERNAL_NAME`
`protected static String` `ITEMS`
`protected static String` `SLING_RESOURCE_TYPE`

### Fields inherited from interface org.apache.sling.api.resource.ResourceProvider

`OWNS_ROOTS, RESOURCE_TYPE_SYNTHETIC, ROOTS, SERVICE_NAME, USE_RESOURCE_ACCESS_SECURITY`

### Constructor Summary

Constructors
`protected` `AbstractReadableResourceProvider​(String resourceRoot)`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected abstract Iterable<String>` `getInternalResourceChildren​(org.apache.sling.api.resource.ResourceResolver resolver, SimplePathInfo pathInfo)`
`protected abstract Map<String,​Object>` `getInternalResourceProperties​(org.apache.sling.api.resource.ResourceResolver resolver, SimplePathInfo pathInfo)`
`org.apache.sling.api.resource.Resource` `getResource​(org.apache.sling.api.resource.ResourceResolver resourceResolver, String path)`
`org.apache.sling.api.resource.Resource` `getResource​(org.apache.sling.api.resource.ResourceResolver resourceResolver, javax.servlet.http.HttpServletRequest request, String path)`
`Iterator<org.apache.sling.api.resource.Resource>` `listChildren​(org.apache.sling.api.resource.Resource parent)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### INTERNAL_ADAPTABLE

    protected static final String INTERNAL_ADAPTABLE

See Also:
  Constant Field Values

#### INTERNAL_NAME

    public static final String INTERNAL_NAME

See Also:
  Constant Field Values

#### INTERNAL_ITEMS_ITERATOR

    protected static final String INTERNAL_ITEMS_ITERATOR

See Also:
  Constant Field Values

#### ITEMS

    protected static final String ITEMS

See Also:
  Constant Field Values

#### SLING_RESOURCE_TYPE

    protected static final String SLING_RESOURCE_TYPE

See Also:
  Constant Field Values

### Constructor Detail

#### AbstractReadableResourceProvider

    protected AbstractReadableResourceProvider​(String resourceRoot)

### Method Detail

#### getResource

    public org.apache.sling.api.resource.Resource getResource​(org.apache.sling.api.resource.ResourceResolver resourceResolver,
                                                              javax.servlet.http.HttpServletRequest request,
                                                              String path)

Specified by:
  `getResource` in interface `org.apache.sling.api.resource.ResourceProvider`

#### getResource

    public org.apache.sling.api.resource.Resource getResource​(org.apache.sling.api.resource.ResourceResolver resourceResolver,
                                                              String path)

Specified by:
  `getResource` in interface `org.apache.sling.api.resource.ResourceProvider`

#### listChildren

    public Iterator<org.apache.sling.api.resource.Resource> listChildren​(org.apache.sling.api.resource.Resource parent)

Specified by:
  `listChildren` in interface `org.apache.sling.api.resource.ResourceProvider`

#### getInternalResourceProperties

    protected abstract Map<String,​Object> getInternalResourceProperties​(org.apache.sling.api.resource.ResourceResolver resolver,
                                                                              SimplePathInfo pathInfo)

#### getInternalResourceChildren

    protected abstract Iterable<String> getInternalResourceChildren​(org.apache.sling.api.resource.ResourceResolver resolver,
                                                                    SimplePathInfo pathInfo)